<?php

/**
 * @file
 * Entity List Field class file.
 */

class EntityListFieldList extends EntityLister {

  public $config;
  public $delta;
  public $flag;
  public $hostItem;

  /**
   * Generate the list.
   *
   * @param array $config
   *   The config options for the list, in an associative array.  See below.
   * @param string $delta
   *   The delta.
   * @param string $field_name
   *   The field name.
   * @param array $host_item
   *   An array describing the item to which this field is attached. See below.
   *
   * The $config array:
   *   $config['type']
   *   $config['bundle']
   *   $config['view_mode']
   *   $config['numitems']
   *   $config['sort']
   *   $config['direction']
   *   $config['terms']
   *   $config['pager']
   *   $config['cache']
   *   $config['status']
   *
   * The $host_item array:
   *   $host_item[0] The host item's entity_id.
   *   $host_item[1] The host item's revision_id.
   *   $host_item[2] The host item's bundle.
   *   $host_item[3] The host item's entity type.
   *
   * We don't need $host_item[1] or $host_item[2] for this class to work,
   * but we have them as a result of our call to entity_extract_ids() in the
   * module file.
   */
  public function __construct($config, $delta, $field_name, $host_item) {

    $this->config = $config;
    $this->delta = $delta;
    $this->flag = $field_name;
    $this->hostItem = $host_item;

  }

}
