/**
 * @file
 * Widget form javascript.
 */

(function($) {
  Drupal.behaviors.entity_list_field = {
    attach: function(context, settings) {

      var entity_list_field = {

        viewModeOps: function(entity_info, type, view_mode) {
          var vm_names = entity_info[type]['view modes'];
          var options = '';
          for (k in vm_names) {
            if (view_mode == k) {
              s = ' selected="selected"';
            }
            else {
              s = '';
            }
            options = options + '<option value="' + k + '"' + s + '>' + vm_names[k].label + '</option>';
          }
          if (0 == options.length) {
            $('select#entity_list_field-view_mode').parent().hide();
          }
          else {
            $('select#entity_list_field-view_mode').parent().show();
            $('select#entity_list_field-view_mode').html(options);
          }
        },

        sortOps: function(property_info, type, sort) {
          var props = property_info[type]['properties'];

          var options = '';
          for (k in props) {
            if ('undefined' !== typeof props[k]['schema field']) {
              if (sort == props[k]['schema field']) {
              s = ' selected="selected"';
              }
              else {
                s = '';
              }
              val = props[k]['schema field'];
              options = options + '<option value="' + val + '"' + s + '>' + props[k].label + '</option>';
            }
          }

          if (0 == options.length) {
            $('select#entity_list_field-sort').parent().hide();
          }
          else {
            $('select#entity_list_field-sort').parent().show();
            $('select#entity_list_field-sort').html(options);
          }
        },

        bundleOps: function(entity_info, type, uncheck) {
          var bundle_names = entity_info[type]['bundles'];
          $('div#bundle_select-input-wrapper input').each(function(index) {
            var cb_val = $(this).val();
            if ('undefined' == typeof bundle_names[cb_val]) {
              $(this).parent().hide();
            } else {
              $(this).parent().show();
            }
            if (uncheck) {
              $(this).attr({checked: false});
              if (0 === index) {
                $('#entity_list_field-bundle').val('');
              }
            }
          });
        },

        bundleVal: function() {
          bundle_vals = new Array();
          $('#bundle_select-input-wrapper input').each(function() {
            if ($(this).attr('checked')) {
              bundle_vals.push($(this).val());
            }
          });
          $('#entity_list_field-bundle').val(JSON.stringify(bundle_vals));
        }
      };

      entity_info = settings.entity_list_field.entity_info;
      property_info = settings.entity_list_field.property_info;
      type = $('#entity_list_field-type').val();
      view_mode = settings.entity_list_field.view_mode;
      sort = settings.entity_list_field.sort;

      entity_list_field.bundleOps(entity_info, type, false);
      entity_list_field.viewModeOps(entity_info, type, view_mode);
      entity_list_field.sortOps(property_info, type, sort);
      entity_list_field.bundleVal();

      // When the type changes, hide the non-appropriate bundles and view modes.
      $('select#entity_list_field-type').change(function() {
        var type = $(this).val();
        entity_list_field.bundleOps(entity_info, type, true);
        entity_list_field.viewModeOps(entity_info, type, view_mode);
        entity_list_field.sortOps(property_info, type, sort);
      });

      $('#bundle_select-input-wrapper input').change(function() {
        entity_list_field.bundleVal();
      });

    }
  };

})(jQuery);
